<template>
  <div class="text_head"><h2>Results</h2></div>
  <div class="search_head">
    <input
      class="search"
      placeholder="Search by result, date"
      v-model="search"
    />
  </div>
  <div class="select_head">
    <select
      name="calculators"
      id="calculators"
      class="select"
      @change="onChange($event)"
      v-model="key"
    >
      <option value="All">All</option>
      <option value="Calculator_A">Calculator A</option>
      <option value="Calculator_B">Calculator B</option>
    </select>
  </div>
  <br><br><br />
  <div class="box">
    <div class="content">
      <div class="container">
        <div v-for="data in filterHistory" v-bind:key="data">
          <div
            v-if="selectCal == 'Calculator_A' && data.name == 'Calculator A'"
          >
            <div class="row">
              <div class="col-6">
                <h2 class="calName">{{ data.name }}</h2>
              </div>
              <div class="col-6">
                <h2 class="Date">{{ data.date }}</h2>
              </div>
            </div>
            <h1 class="result">{{ data.result }}</h1>
            <hr class="hisLine" />
            <h2 class="operation">{{ data.operation }}</h2>
          </div>

          <div
            v-if="selectCal == 'Calculator_B' && data.name == 'Calculator B'"
          >
            <div class="row">
              <div class="col-6">
                <h2 class="calName">{{ data.name }}</h2>
              </div>
              <div class="col-6">
                <h2 class="Date">{{ data.date }}</h2>
              </div>
            </div>
            <h1 class="result">{{ data.result }}</h1>
            <hr class="hisLine" />
            <h2 class="operation">{{ data.operation }}</h2>
          </div>

          <div v-if="selectCal == 'All'">
            <div class="row">
              <div class="col-6">
                <h2 class="calName">{{ data.name }}</h2>
              </div>
              <div class="col-6">
                <h2 class="Date">{{ data.date }}</h2>
              </div>
            </div>
            <h1 class="result">{{ data.result }}</h1>
            <hr class="hisLine" />
            <h2 class="operation">{{ data.operation }}</h2>
          </div>
        </div>
      </div>
      <button class="clear" @click="onClear()">Clear</button>
    </div>
  </div>
</template>

<script>
export default {
  name: "History",
  data() {
    return {
      hisResult: [],
      allHistory: [],
      key: "All",
      selectCal: "All",
      search: "",
    };
  },
  computed: {
    filterHistory() {
      this.setData();
      return this.hisResult.filter((history) => {
        return (
          history.result.toString().match(this.search) ||
          history.date.toString().match(this.search)
        );
      });
    },
  },
  methods: {
    onClear() {
      if (confirm("Do you want to clear all history?")) {
        localStorage.clear();
        this.allHistory = [];
        this.hisResult = [];
      }
    },
    onChange(event) {
      this.selectCal = event.target.value;
      // console.log("Change to " + this.selectCal);
    },
    setData() {
      if (JSON.parse(localStorage.getItem("historyList"))) {
        this.hisResult = JSON.parse(localStorage.getItem("historyList"));
      }
      // console.log(this.hisResult);
    },
  },
};
</script>

<style scoped>
.text_head {
  float: left;
  width: 20%;
  color: #707070;
}
.search_head {
  float: left;
  width: 60%;
}
.select_head {
  float: left;
  width: 20%;
}
.search,
.select {
  width: 95%;
  border-radius: 13px;
  border-color: #c9c9c9;
  height: 40px;
  border-width: thin;
  box-shadow: 0 2px 5px -1px rgba(0, 0, 0, 0.25);
  font-size: x-large;
}
@media screen and (max-width: 500px) {
  .text_head,
  .search_head,
  .select_head {
    width: 100%; /* The width is 100%, when the viewport is 800px or smaller */
  }
}

.box {
  float: left;
  width: 100%;
  height: 600px;
  border-radius: 20px;
  position: relative;
  background-color: white;
}
.content {
  overflow: auto;
  width: 100%;
  height: 100%;
  -ms-overflow-style: none; /* IE and Edge */
  scrollbar-width: none; /* Firefox */
}
/* Hide scrollbar for Chrome, Safari and Opera */
.content::-webkit-scrollbar {
  display: none;
}
/* .container{
  display: flex;
  flex-direction: column;
  flex-wrap: wrap;
} */
button {
  position: absolute;
  bottom: 1.5rem;
  right: 1.5rem;
  border-radius: 13px;
  background-color: #faa7a7;
  border-color: #faa7a7;
  color: white;
  font-size: xx-large;
  padding: 3px 10px;
  border-style: hidden;
  width: 14%;
  height: 10%;
}
@media screen and (max-width: 700px) {
  .clear {
    width: 30%;
  }
}
.calName {
  color: #707070;
  font-weight: 490;
}
.Date {
  color: #9ac2e3;
  float: right;
  font-weight: 400;
}
.result{
  font-size: calc(1.375rem + 2vw);
  font-weight: 490;
  color: #707070;
}
.operation{
  color: #707070;
}
</style>
